﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using HPSocket;
using HPSocket.Tcp;
using Model;
using System.IO;

namespace ADCtrlFunc
{ 
    public class ADCtrlBoard : UserControl
    {
        [DllImport("kernel32.dll")]
        static extern uint GetTickCount();

        [DllImport("kernel32.dll")]
        public static extern int WinExec(string exeName, int operType);

        private AdText ad_text;
        private static bool[] ad_input_states_arr = new bool[16];
        private static bool[] ad_input_states_arr_old = new bool[16];

        #region 定义控件
        private Label label2;
        private Label label4;
        private Label lblValue;
        private Label label3;
        private Label label1;
        private VerticalProgressBar.VerticalProgressBar verticalProgressBar16;
        private VerticalProgressBar.VerticalProgressBar verticalProgressBar14;
        private VerticalProgressBar.VerticalProgressBar verticalProgressBar10;
        private VerticalProgressBar.VerticalProgressBar verticalProgressBar15;
        private VerticalProgressBar.VerticalProgressBar verticalProgressBar13;
        private VerticalProgressBar.VerticalProgressBar verticalProgressBar9;
        private VerticalProgressBar.VerticalProgressBar verticalProgressBar12;
        private VerticalProgressBar.VerticalProgressBar verticalProgressBar8;
        private VerticalProgressBar.VerticalProgressBar verticalProgressBar11;
        private VerticalProgressBar.VerticalProgressBar verticalProgressBar7;
        private VerticalProgressBar.VerticalProgressBar verticalProgressBar6;
        private VerticalProgressBar.VerticalProgressBar verticalProgressBar5;
        private VerticalProgressBar.VerticalProgressBar verticalProgressBar4;
        private VerticalProgressBar.VerticalProgressBar verticalProgressBar3;
        private VerticalProgressBar.VerticalProgressBar verticalProgressBar2;
        private VerticalProgressBar.VerticalProgressBar verticalProgressBar1;
        private Label label19;
        private Label label18;
        private Label label15;
        private Label label14;
        private Label label11;
        private Label label17;
        private Label label10;
        private Label label13;
        private Label label7;
        private Label label16;
        private Label label9;
        private Label label12;
        private Label label6;
        private Label label8;
        private Label label33;
        private Label label32;
        private Label label31;
        private Label label30;
        private Label label29;
        private Label label28;
        private Label label27;
        private Label label26;
        private Label label25;
        private Label label24;
        private Label label23;
        private Label label22;
        private Label label21;
        private Label label20;
        private Label label47;
        private Label label46;
        private Label label45;
        private Label label44;
        private Label label43;
        private Label label42;
        private Label label41;
        private Label label40;
        private Label label39;
        private Label label38;
        private Label label37;
        private Label label36;
        private Label label35;
        private Label label34;
        private Label label5;
        private GroupBox gbInputSensor;
        private PictureBox pictureBox16;
        private PictureBox pictureBox8;
        private PictureBox pictureBox15;
        private PictureBox pictureBox7;
        private PictureBox pictureBox14;
        private PictureBox pictureBox6;
        private PictureBox pictureBox13;
        private PictureBox pictureBox5;
        private PictureBox pictureBox12;
        private PictureBox pictureBox4;
        private PictureBox pictureBox11;
        private PictureBox pictureBox3;
        private PictureBox pictureBox10;
        private PictureBox pictureBox2;
        private PictureBox pictureBox9;
        private Label label63;
        private Label label55;
        private Label label62;
        private Label label54;
        private Label label61;
        private Label label53;
        private Label label60;
        private Label label52;
        private Label label59;
        private Label label51;
        private Label label58;
        private Label label50;
        private Label label57;
        private Label label49;
        private Label label56;
        private Label label48;
        private PictureBox pictureBox1;
        private GroupBox gbTempSensor;
        private VerticalProgressBar.VerticalProgressBar verticalProgressBar21;
        private VerticalProgressBar.VerticalProgressBar verticalProgressBar19;
        private VerticalProgressBar.VerticalProgressBar verticalProgressBar20;
        private VerticalProgressBar.VerticalProgressBar verticalProgressBar17;
        private VerticalProgressBar.VerticalProgressBar verticalProgressBar18;
        private Label label68;
        private Label label64;
        private Label label65;
        private Label label67;
        private Label label66;
        private GroupBox gbCmd;
        private Button btnConnect;
        private Button btnRemove;
        private CheckBox chkTmr;
        private Button btnAutoReport;
        private CheckBox chkCF;
        private Label label71;
        private Label label69;
        private Label label70;
        private Label label72;
        private Label label73;
        private Button btnChange;
        private GroupBox gbAnalogSensor;

        #endregion

        #region 定义控件布局


        private void InitializeComponent()
        {
            this.gbAnalogSensor = new System.Windows.Forms.GroupBox();
            this.label47 = new System.Windows.Forms.Label();
            this.label46 = new System.Windows.Forms.Label();
            this.label45 = new System.Windows.Forms.Label();
            this.label44 = new System.Windows.Forms.Label();
            this.label43 = new System.Windows.Forms.Label();
            this.label42 = new System.Windows.Forms.Label();
            this.label41 = new System.Windows.Forms.Label();
            this.label40 = new System.Windows.Forms.Label();
            this.label39 = new System.Windows.Forms.Label();
            this.label38 = new System.Windows.Forms.Label();
            this.label37 = new System.Windows.Forms.Label();
            this.label36 = new System.Windows.Forms.Label();
            this.label35 = new System.Windows.Forms.Label();
            this.label34 = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.label33 = new System.Windows.Forms.Label();
            this.label32 = new System.Windows.Forms.Label();
            this.label31 = new System.Windows.Forms.Label();
            this.label30 = new System.Windows.Forms.Label();
            this.label29 = new System.Windows.Forms.Label();
            this.label28 = new System.Windows.Forms.Label();
            this.label27 = new System.Windows.Forms.Label();
            this.label26 = new System.Windows.Forms.Label();
            this.label25 = new System.Windows.Forms.Label();
            this.label24 = new System.Windows.Forms.Label();
            this.label23 = new System.Windows.Forms.Label();
            this.label22 = new System.Windows.Forms.Label();
            this.label21 = new System.Windows.Forms.Label();
            this.label20 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.lblValue = new System.Windows.Forms.Label();
            this.label19 = new System.Windows.Forms.Label();
            this.label18 = new System.Windows.Forms.Label();
            this.label15 = new System.Windows.Forms.Label();
            this.label14 = new System.Windows.Forms.Label();
            this.label11 = new System.Windows.Forms.Label();
            this.label17 = new System.Windows.Forms.Label();
            this.label10 = new System.Windows.Forms.Label();
            this.label13 = new System.Windows.Forms.Label();
            this.label7 = new System.Windows.Forms.Label();
            this.label16 = new System.Windows.Forms.Label();
            this.label9 = new System.Windows.Forms.Label();
            this.label12 = new System.Windows.Forms.Label();
            this.label6 = new System.Windows.Forms.Label();
            this.label8 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.label1 = new System.Windows.Forms.Label();
            this.verticalProgressBar16 = new VerticalProgressBar.VerticalProgressBar();
            this.verticalProgressBar14 = new VerticalProgressBar.VerticalProgressBar();
            this.verticalProgressBar10 = new VerticalProgressBar.VerticalProgressBar();
            this.verticalProgressBar15 = new VerticalProgressBar.VerticalProgressBar();
            this.verticalProgressBar13 = new VerticalProgressBar.VerticalProgressBar();
            this.verticalProgressBar9 = new VerticalProgressBar.VerticalProgressBar();
            this.verticalProgressBar12 = new VerticalProgressBar.VerticalProgressBar();
            this.verticalProgressBar8 = new VerticalProgressBar.VerticalProgressBar();
            this.verticalProgressBar11 = new VerticalProgressBar.VerticalProgressBar();
            this.verticalProgressBar7 = new VerticalProgressBar.VerticalProgressBar();
            this.verticalProgressBar6 = new VerticalProgressBar.VerticalProgressBar();
            this.verticalProgressBar5 = new VerticalProgressBar.VerticalProgressBar();
            this.verticalProgressBar4 = new VerticalProgressBar.VerticalProgressBar();
            this.verticalProgressBar3 = new VerticalProgressBar.VerticalProgressBar();
            this.verticalProgressBar2 = new VerticalProgressBar.VerticalProgressBar();
            this.verticalProgressBar1 = new VerticalProgressBar.VerticalProgressBar();
            this.gbInputSensor = new System.Windows.Forms.GroupBox();
            this.pictureBox16 = new System.Windows.Forms.PictureBox();
            this.pictureBox8 = new System.Windows.Forms.PictureBox();
            this.pictureBox15 = new System.Windows.Forms.PictureBox();
            this.pictureBox7 = new System.Windows.Forms.PictureBox();
            this.pictureBox14 = new System.Windows.Forms.PictureBox();
            this.pictureBox6 = new System.Windows.Forms.PictureBox();
            this.pictureBox13 = new System.Windows.Forms.PictureBox();
            this.pictureBox5 = new System.Windows.Forms.PictureBox();
            this.pictureBox12 = new System.Windows.Forms.PictureBox();
            this.pictureBox4 = new System.Windows.Forms.PictureBox();
            this.pictureBox11 = new System.Windows.Forms.PictureBox();
            this.pictureBox3 = new System.Windows.Forms.PictureBox();
            this.pictureBox10 = new System.Windows.Forms.PictureBox();
            this.pictureBox2 = new System.Windows.Forms.PictureBox();
            this.pictureBox9 = new System.Windows.Forms.PictureBox();
            this.label63 = new System.Windows.Forms.Label();
            this.label55 = new System.Windows.Forms.Label();
            this.label62 = new System.Windows.Forms.Label();
            this.label54 = new System.Windows.Forms.Label();
            this.label61 = new System.Windows.Forms.Label();
            this.label53 = new System.Windows.Forms.Label();
            this.label60 = new System.Windows.Forms.Label();
            this.label52 = new System.Windows.Forms.Label();
            this.label59 = new System.Windows.Forms.Label();
            this.label51 = new System.Windows.Forms.Label();
            this.label58 = new System.Windows.Forms.Label();
            this.label50 = new System.Windows.Forms.Label();
            this.label57 = new System.Windows.Forms.Label();
            this.label49 = new System.Windows.Forms.Label();
            this.label56 = new System.Windows.Forms.Label();
            this.label48 = new System.Windows.Forms.Label();
            this.pictureBox1 = new System.Windows.Forms.PictureBox();
            this.gbTempSensor = new System.Windows.Forms.GroupBox();
            this.chkCF = new System.Windows.Forms.CheckBox();
            this.verticalProgressBar21 = new VerticalProgressBar.VerticalProgressBar();
            this.verticalProgressBar19 = new VerticalProgressBar.VerticalProgressBar();
            this.verticalProgressBar20 = new VerticalProgressBar.VerticalProgressBar();
            this.verticalProgressBar17 = new VerticalProgressBar.VerticalProgressBar();
            this.verticalProgressBar18 = new VerticalProgressBar.VerticalProgressBar();
            this.label68 = new System.Windows.Forms.Label();
            this.label64 = new System.Windows.Forms.Label();
            this.label65 = new System.Windows.Forms.Label();
            this.label67 = new System.Windows.Forms.Label();
            this.label66 = new System.Windows.Forms.Label();
            this.gbCmd = new System.Windows.Forms.GroupBox();
            this.btnAutoReport = new System.Windows.Forms.Button();
            this.chkTmr = new System.Windows.Forms.CheckBox();
            this.btnConnect = new System.Windows.Forms.Button();
            this.btnRemove = new System.Windows.Forms.Button();
            this.label72 = new System.Windows.Forms.Label();
            this.label73 = new System.Windows.Forms.Label();
            this.label71 = new System.Windows.Forms.Label();
            this.label70 = new System.Windows.Forms.Label();
            this.label69 = new System.Windows.Forms.Label();
            this.btnChange = new System.Windows.Forms.Button();
            this.gbAnalogSensor.SuspendLayout();
            this.gbInputSensor.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox16)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox8)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox15)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox7)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox14)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox6)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox13)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox5)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox12)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox4)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox11)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox3)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox10)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox2)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox9)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).BeginInit();
            this.gbTempSensor.SuspendLayout();
            this.gbCmd.SuspendLayout();
            this.SuspendLayout();
            // 
            // gbAnalogSensor
            // 
            this.gbAnalogSensor.Controls.Add(this.label47);
            this.gbAnalogSensor.Controls.Add(this.label46);
            this.gbAnalogSensor.Controls.Add(this.label45);
            this.gbAnalogSensor.Controls.Add(this.label44);
            this.gbAnalogSensor.Controls.Add(this.label43);
            this.gbAnalogSensor.Controls.Add(this.label42);
            this.gbAnalogSensor.Controls.Add(this.label41);
            this.gbAnalogSensor.Controls.Add(this.label40);
            this.gbAnalogSensor.Controls.Add(this.label39);
            this.gbAnalogSensor.Controls.Add(this.label38);
            this.gbAnalogSensor.Controls.Add(this.label37);
            this.gbAnalogSensor.Controls.Add(this.label36);
            this.gbAnalogSensor.Controls.Add(this.label35);
            this.gbAnalogSensor.Controls.Add(this.label34);
            this.gbAnalogSensor.Controls.Add(this.label5);
            this.gbAnalogSensor.Controls.Add(this.label2);
            this.gbAnalogSensor.Controls.Add(this.label33);
            this.gbAnalogSensor.Controls.Add(this.label32);
            this.gbAnalogSensor.Controls.Add(this.label31);
            this.gbAnalogSensor.Controls.Add(this.label30);
            this.gbAnalogSensor.Controls.Add(this.label29);
            this.gbAnalogSensor.Controls.Add(this.label28);
            this.gbAnalogSensor.Controls.Add(this.label27);
            this.gbAnalogSensor.Controls.Add(this.label26);
            this.gbAnalogSensor.Controls.Add(this.label25);
            this.gbAnalogSensor.Controls.Add(this.label24);
            this.gbAnalogSensor.Controls.Add(this.label23);
            this.gbAnalogSensor.Controls.Add(this.label22);
            this.gbAnalogSensor.Controls.Add(this.label21);
            this.gbAnalogSensor.Controls.Add(this.label20);
            this.gbAnalogSensor.Controls.Add(this.label4);
            this.gbAnalogSensor.Controls.Add(this.lblValue);
            this.gbAnalogSensor.Controls.Add(this.label19);
            this.gbAnalogSensor.Controls.Add(this.label18);
            this.gbAnalogSensor.Controls.Add(this.label15);
            this.gbAnalogSensor.Controls.Add(this.label14);
            this.gbAnalogSensor.Controls.Add(this.label11);
            this.gbAnalogSensor.Controls.Add(this.label17);
            this.gbAnalogSensor.Controls.Add(this.label10);
            this.gbAnalogSensor.Controls.Add(this.label13);
            this.gbAnalogSensor.Controls.Add(this.label7);
            this.gbAnalogSensor.Controls.Add(this.label16);
            this.gbAnalogSensor.Controls.Add(this.label9);
            this.gbAnalogSensor.Controls.Add(this.label12);
            this.gbAnalogSensor.Controls.Add(this.label6);
            this.gbAnalogSensor.Controls.Add(this.label8);
            this.gbAnalogSensor.Controls.Add(this.label3);
            this.gbAnalogSensor.Controls.Add(this.label1);
            this.gbAnalogSensor.Controls.Add(this.verticalProgressBar16);
            this.gbAnalogSensor.Controls.Add(this.verticalProgressBar14);
            this.gbAnalogSensor.Controls.Add(this.verticalProgressBar10);
            this.gbAnalogSensor.Controls.Add(this.verticalProgressBar15);
            this.gbAnalogSensor.Controls.Add(this.verticalProgressBar13);
            this.gbAnalogSensor.Controls.Add(this.verticalProgressBar9);
            this.gbAnalogSensor.Controls.Add(this.verticalProgressBar12);
            this.gbAnalogSensor.Controls.Add(this.verticalProgressBar8);
            this.gbAnalogSensor.Controls.Add(this.verticalProgressBar11);
            this.gbAnalogSensor.Controls.Add(this.verticalProgressBar7);
            this.gbAnalogSensor.Controls.Add(this.verticalProgressBar6);
            this.gbAnalogSensor.Controls.Add(this.verticalProgressBar5);
            this.gbAnalogSensor.Controls.Add(this.verticalProgressBar4);
            this.gbAnalogSensor.Controls.Add(this.verticalProgressBar3);
            this.gbAnalogSensor.Controls.Add(this.verticalProgressBar2);
            this.gbAnalogSensor.Controls.Add(this.verticalProgressBar1);
            this.gbAnalogSensor.Location = new System.Drawing.Point(10, 10);
            this.gbAnalogSensor.Name = "gbAnalogSensor";
            this.gbAnalogSensor.Size = new System.Drawing.Size(950, 227);
            this.gbAnalogSensor.TabIndex = 0;
            this.gbAnalogSensor.TabStop = false;
            this.gbAnalogSensor.Text = "Analog Input Sensor";
            // 
            // label47
            // 
            this.label47.Location = new System.Drawing.Point(880, 198);
            this.label47.Name = "label47";
            this.label47.Size = new System.Drawing.Size(30, 23);
            this.label47.TabIndex = 2;
            this.label47.Tag = "36";
            this.label47.Text = "pa";
            this.label47.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label46
            // 
            this.label46.Location = new System.Drawing.Point(823, 198);
            this.label46.Name = "label46";
            this.label46.Size = new System.Drawing.Size(30, 23);
            this.label46.TabIndex = 2;
            this.label46.Tag = "35";
            this.label46.Text = "pa";
            this.label46.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label45
            // 
            this.label45.Location = new System.Drawing.Point(766, 198);
            this.label45.Name = "label45";
            this.label45.Size = new System.Drawing.Size(30, 23);
            this.label45.TabIndex = 2;
            this.label45.Tag = "34";
            this.label45.Text = "pa";
            this.label45.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label44
            // 
            this.label44.Location = new System.Drawing.Point(709, 198);
            this.label44.Name = "label44";
            this.label44.Size = new System.Drawing.Size(30, 23);
            this.label44.TabIndex = 2;
            this.label44.Tag = "33";
            this.label44.Text = "pa";
            this.label44.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label43
            // 
            this.label43.Location = new System.Drawing.Point(652, 198);
            this.label43.Name = "label43";
            this.label43.Size = new System.Drawing.Size(30, 23);
            this.label43.TabIndex = 2;
            this.label43.Tag = "32";
            this.label43.Text = "pa";
            this.label43.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label42
            // 
            this.label42.Location = new System.Drawing.Point(595, 198);
            this.label42.Name = "label42";
            this.label42.Size = new System.Drawing.Size(30, 23);
            this.label42.TabIndex = 2;
            this.label42.Tag = "31";
            this.label42.Text = "pa";
            this.label42.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label41
            // 
            this.label41.Location = new System.Drawing.Point(538, 198);
            this.label41.Name = "label41";
            this.label41.Size = new System.Drawing.Size(30, 23);
            this.label41.TabIndex = 2;
            this.label41.Tag = "30";
            this.label41.Text = "pa";
            this.label41.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label40
            // 
            this.label40.Location = new System.Drawing.Point(481, 198);
            this.label40.Name = "label40";
            this.label40.Size = new System.Drawing.Size(30, 23);
            this.label40.TabIndex = 2;
            this.label40.Tag = "29";
            this.label40.Text = "pa";
            this.label40.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label39
            // 
            this.label39.Location = new System.Drawing.Point(424, 198);
            this.label39.Name = "label39";
            this.label39.Size = new System.Drawing.Size(30, 23);
            this.label39.TabIndex = 2;
            this.label39.Tag = "28";
            this.label39.Text = "pa";
            this.label39.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label38
            // 
            this.label38.Location = new System.Drawing.Point(367, 198);
            this.label38.Name = "label38";
            this.label38.Size = new System.Drawing.Size(30, 23);
            this.label38.TabIndex = 2;
            this.label38.Tag = "27";
            this.label38.Text = "pa";
            this.label38.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label37
            // 
            this.label37.Location = new System.Drawing.Point(310, 198);
            this.label37.Name = "label37";
            this.label37.Size = new System.Drawing.Size(30, 23);
            this.label37.TabIndex = 2;
            this.label37.Tag = "26";
            this.label37.Text = "pa";
            this.label37.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label36
            // 
            this.label36.Location = new System.Drawing.Point(253, 198);
            this.label36.Name = "label36";
            this.label36.Size = new System.Drawing.Size(30, 23);
            this.label36.TabIndex = 2;
            this.label36.Tag = "25";
            this.label36.Text = "pa";
            this.label36.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label35
            // 
            this.label35.Location = new System.Drawing.Point(196, 198);
            this.label35.Name = "label35";
            this.label35.Size = new System.Drawing.Size(30, 23);
            this.label35.TabIndex = 2;
            this.label35.Tag = "24";
            this.label35.Text = "pa";
            this.label35.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label34
            // 
            this.label34.Location = new System.Drawing.Point(139, 198);
            this.label34.Name = "label34";
            this.label34.Size = new System.Drawing.Size(30, 23);
            this.label34.TabIndex = 2;
            this.label34.Tag = "23";
            this.label34.Text = "pa";
            this.label34.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label5
            // 
            this.label5.Location = new System.Drawing.Point(82, 198);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(30, 23);
            this.label5.TabIndex = 2;
            this.label5.Tag = "22";
            this.label5.Text = "pa";
            this.label5.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(25, 198);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(30, 23);
            this.label2.TabIndex = 2;
            this.label2.Tag = "21";
            this.label2.Text = "pa";
            this.label2.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label33
            // 
            this.label33.Location = new System.Drawing.Point(875, 182);
            this.label33.Name = "label33";
            this.label33.Size = new System.Drawing.Size(39, 15);
            this.label33.TabIndex = 2;
            this.label33.Tag = "16";
            this.label33.Text = "0.00";
            this.label33.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label32
            // 
            this.label32.Location = new System.Drawing.Point(818, 182);
            this.label32.Name = "label32";
            this.label32.Size = new System.Drawing.Size(39, 15);
            this.label32.TabIndex = 2;
            this.label32.Tag = "15";
            this.label32.Text = "0.00";
            this.label32.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label31
            // 
            this.label31.Location = new System.Drawing.Point(761, 182);
            this.label31.Name = "label31";
            this.label31.Size = new System.Drawing.Size(39, 15);
            this.label31.TabIndex = 2;
            this.label31.Tag = "14";
            this.label31.Text = "0.00";
            this.label31.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label30
            // 
            this.label30.Location = new System.Drawing.Point(704, 182);
            this.label30.Name = "label30";
            this.label30.Size = new System.Drawing.Size(39, 15);
            this.label30.TabIndex = 2;
            this.label30.Tag = "13";
            this.label30.Text = "0.00";
            this.label30.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label29
            // 
            this.label29.Location = new System.Drawing.Point(647, 182);
            this.label29.Name = "label29";
            this.label29.Size = new System.Drawing.Size(39, 15);
            this.label29.TabIndex = 2;
            this.label29.Tag = "12";
            this.label29.Text = "0.00";
            this.label29.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label28
            // 
            this.label28.Location = new System.Drawing.Point(590, 182);
            this.label28.Name = "label28";
            this.label28.Size = new System.Drawing.Size(39, 15);
            this.label28.TabIndex = 2;
            this.label28.Tag = "11";
            this.label28.Text = "0.00";
            this.label28.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label27
            // 
            this.label27.Location = new System.Drawing.Point(533, 182);
            this.label27.Name = "label27";
            this.label27.Size = new System.Drawing.Size(39, 15);
            this.label27.TabIndex = 2;
            this.label27.Tag = "10";
            this.label27.Text = "0.00";
            this.label27.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label26
            // 
            this.label26.Location = new System.Drawing.Point(476, 182);
            this.label26.Name = "label26";
            this.label26.Size = new System.Drawing.Size(39, 15);
            this.label26.TabIndex = 2;
            this.label26.Tag = "9";
            this.label26.Text = "0.00";
            this.label26.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label25
            // 
            this.label25.Location = new System.Drawing.Point(419, 182);
            this.label25.Name = "label25";
            this.label25.Size = new System.Drawing.Size(39, 15);
            this.label25.TabIndex = 2;
            this.label25.Tag = "8";
            this.label25.Text = "0.00";
            this.label25.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label24
            // 
            this.label24.Location = new System.Drawing.Point(362, 182);
            this.label24.Name = "label24";
            this.label24.Size = new System.Drawing.Size(39, 15);
            this.label24.TabIndex = 2;
            this.label24.Tag = "7";
            this.label24.Text = "0.00";
            this.label24.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label23
            // 
            this.label23.Location = new System.Drawing.Point(305, 182);
            this.label23.Name = "label23";
            this.label23.Size = new System.Drawing.Size(39, 15);
            this.label23.TabIndex = 2;
            this.label23.Tag = "6";
            this.label23.Text = "0.00";
            this.label23.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label22
            // 
            this.label22.Location = new System.Drawing.Point(248, 182);
            this.label22.Name = "label22";
            this.label22.Size = new System.Drawing.Size(39, 15);
            this.label22.TabIndex = 2;
            this.label22.Tag = "5";
            this.label22.Text = "0.00";
            this.label22.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label21
            // 
            this.label21.Location = new System.Drawing.Point(191, 182);
            this.label21.Name = "label21";
            this.label21.Size = new System.Drawing.Size(39, 15);
            this.label21.TabIndex = 2;
            this.label21.Tag = "4";
            this.label21.Text = "0.00";
            this.label21.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label20
            // 
            this.label20.Location = new System.Drawing.Point(138, 182);
            this.label20.Name = "label20";
            this.label20.Size = new System.Drawing.Size(39, 15);
            this.label20.TabIndex = 2;
            this.label20.Tag = "3";
            this.label20.Text = "0.00";
            this.label20.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(78, 182);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(39, 15);
            this.label4.TabIndex = 2;
            this.label4.Tag = "2";
            this.label4.Text = "0.00";
            this.label4.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // lblValue
            // 
            this.lblValue.Location = new System.Drawing.Point(20, 182);
            this.lblValue.Name = "lblValue";
            this.lblValue.Size = new System.Drawing.Size(39, 15);
            this.lblValue.TabIndex = 2;
            this.lblValue.Tag = "1";
            this.lblValue.Text = "0.00";
            this.lblValue.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label19
            // 
            this.label19.Location = new System.Drawing.Point(877, 21);
            this.label19.Name = "label19";
            this.label19.Size = new System.Drawing.Size(45, 15);
            this.label19.TabIndex = 2;
            this.label19.Tag = "56";
            this.label19.Text = "16";
            this.label19.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // label18
            // 
            this.label18.Location = new System.Drawing.Point(819, 21);
            this.label18.Name = "label18";
            this.label18.Size = new System.Drawing.Size(45, 15);
            this.label18.TabIndex = 2;
            this.label18.Tag = "55";
            this.label18.Text = "15";
            this.label18.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // label15
            // 
            this.label15.Location = new System.Drawing.Point(645, 21);
            this.label15.Name = "label15";
            this.label15.Size = new System.Drawing.Size(45, 15);
            this.label15.TabIndex = 2;
            this.label15.Tag = "52";
            this.label15.Text = "12";
            this.label15.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // label14
            // 
            this.label14.Location = new System.Drawing.Point(588, 21);
            this.label14.Name = "label14";
            this.label14.Size = new System.Drawing.Size(45, 15);
            this.label14.TabIndex = 2;
            this.label14.Tag = "51";
            this.label14.Text = "11";
            this.label14.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // label11
            // 
            this.label11.Location = new System.Drawing.Point(417, 21);
            this.label11.Name = "label11";
            this.label11.Size = new System.Drawing.Size(45, 15);
            this.label11.TabIndex = 2;
            this.label11.Tag = "48";
            this.label11.Text = "8";
            this.label11.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // label17
            // 
            this.label17.Location = new System.Drawing.Point(759, 21);
            this.label17.Name = "label17";
            this.label17.Size = new System.Drawing.Size(45, 15);
            this.label17.TabIndex = 2;
            this.label17.Tag = "54";
            this.label17.Text = "14";
            this.label17.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // label10
            // 
            this.label10.Location = new System.Drawing.Point(360, 21);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(45, 15);
            this.label10.TabIndex = 2;
            this.label10.Tag = "47";
            this.label10.Text = "7";
            this.label10.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // label13
            // 
            this.label13.Location = new System.Drawing.Point(531, 21);
            this.label13.Name = "label13";
            this.label13.Size = new System.Drawing.Size(45, 15);
            this.label13.TabIndex = 2;
            this.label13.Tag = "50";
            this.label13.Text = "10";
            this.label13.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // label7
            // 
            this.label7.Location = new System.Drawing.Point(189, 21);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(45, 15);
            this.label7.TabIndex = 2;
            this.label7.Tag = "44";
            this.label7.Text = "4";
            this.label7.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // label16
            // 
            this.label16.Location = new System.Drawing.Point(702, 21);
            this.label16.Name = "label16";
            this.label16.Size = new System.Drawing.Size(45, 15);
            this.label16.TabIndex = 2;
            this.label16.Tag = "53";
            this.label16.Text = "13";
            this.label16.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // label9
            // 
            this.label9.Location = new System.Drawing.Point(303, 21);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(45, 15);
            this.label9.TabIndex = 2;
            this.label9.Tag = "46";
            this.label9.Text = "6";
            this.label9.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // label12
            // 
            this.label12.Location = new System.Drawing.Point(474, 21);
            this.label12.Name = "label12";
            this.label12.Size = new System.Drawing.Size(45, 15);
            this.label12.TabIndex = 2;
            this.label12.Tag = "49";
            this.label12.Text = "9";
            this.label12.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // label6
            // 
            this.label6.Location = new System.Drawing.Point(133, 21);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(45, 15);
            this.label6.TabIndex = 2;
            this.label6.Tag = "43";
            this.label6.Text = "3";
            this.label6.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // label8
            // 
            this.label8.Location = new System.Drawing.Point(246, 21);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(45, 15);
            this.label8.TabIndex = 2;
            this.label8.Tag = "45";
            this.label8.Text = "5";
            this.label8.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(76, 21);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(45, 15);
            this.label3.TabIndex = 2;
            this.label3.Tag = "42";
            this.label3.Text = "2";
            this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(21, 21);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(45, 15);
            this.label1.TabIndex = 2;
            this.label1.Tag = "41";
            this.label1.Text = "1";
            this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // verticalProgressBar16
            // 
            this.verticalProgressBar16.Location = new System.Drawing.Point(884, 39);
            this.verticalProgressBar16.Name = "verticalProgressBar16";
            this.verticalProgressBar16.Size = new System.Drawing.Size(25, 140);
            this.verticalProgressBar16.TabIndex = 1;
            this.verticalProgressBar16.Tag = "16";
            // 
            // verticalProgressBar14
            // 
            this.verticalProgressBar14.Location = new System.Drawing.Point(770, 39);
            this.verticalProgressBar14.Name = "verticalProgressBar14";
            this.verticalProgressBar14.Size = new System.Drawing.Size(25, 140);
            this.verticalProgressBar14.TabIndex = 1;
            this.verticalProgressBar14.Tag = "14";
            // 
            // verticalProgressBar10
            // 
            this.verticalProgressBar10.Location = new System.Drawing.Point(542, 39);
            this.verticalProgressBar10.Name = "verticalProgressBar10";
            this.verticalProgressBar10.Size = new System.Drawing.Size(25, 140);
            this.verticalProgressBar10.TabIndex = 1;
            this.verticalProgressBar10.Tag = "10";
            // 
            // verticalProgressBar15
            // 
            this.verticalProgressBar15.Location = new System.Drawing.Point(827, 39);
            this.verticalProgressBar15.Name = "verticalProgressBar15";
            this.verticalProgressBar15.Size = new System.Drawing.Size(25, 140);
            this.verticalProgressBar15.TabIndex = 1;
            this.verticalProgressBar15.Tag = "15";
            // 
            // verticalProgressBar13
            // 
            this.verticalProgressBar13.Location = new System.Drawing.Point(713, 39);
            this.verticalProgressBar13.Name = "verticalProgressBar13";
            this.verticalProgressBar13.Size = new System.Drawing.Size(25, 140);
            this.verticalProgressBar13.TabIndex = 1;
            this.verticalProgressBar13.Tag = "13";
            // 
            // verticalProgressBar9
            // 
            this.verticalProgressBar9.Location = new System.Drawing.Point(485, 39);
            this.verticalProgressBar9.Name = "verticalProgressBar9";
            this.verticalProgressBar9.Size = new System.Drawing.Size(25, 140);
            this.verticalProgressBar9.TabIndex = 1;
            this.verticalProgressBar9.Tag = "9";
            // 
            // verticalProgressBar12
            // 
            this.verticalProgressBar12.Location = new System.Drawing.Point(656, 39);
            this.verticalProgressBar12.Name = "verticalProgressBar12";
            this.verticalProgressBar12.Size = new System.Drawing.Size(25, 140);
            this.verticalProgressBar12.TabIndex = 1;
            this.verticalProgressBar12.Tag = "12";
            // 
            // verticalProgressBar8
            // 
            this.verticalProgressBar8.Location = new System.Drawing.Point(428, 39);
            this.verticalProgressBar8.Name = "verticalProgressBar8";
            this.verticalProgressBar8.Size = new System.Drawing.Size(25, 140);
            this.verticalProgressBar8.TabIndex = 1;
            this.verticalProgressBar8.Tag = "8";
            // 
            // verticalProgressBar11
            // 
            this.verticalProgressBar11.Location = new System.Drawing.Point(599, 39);
            this.verticalProgressBar11.Name = "verticalProgressBar11";
            this.verticalProgressBar11.Size = new System.Drawing.Size(25, 140);
            this.verticalProgressBar11.TabIndex = 1;
            this.verticalProgressBar11.Tag = "11";
            // 
            // verticalProgressBar7
            // 
            this.verticalProgressBar7.Location = new System.Drawing.Point(371, 39);
            this.verticalProgressBar7.Name = "verticalProgressBar7";
            this.verticalProgressBar7.Size = new System.Drawing.Size(25, 140);
            this.verticalProgressBar7.TabIndex = 1;
            this.verticalProgressBar7.Tag = "7";
            // 
            // verticalProgressBar6
            // 
            this.verticalProgressBar6.Location = new System.Drawing.Point(314, 39);
            this.verticalProgressBar6.Name = "verticalProgressBar6";
            this.verticalProgressBar6.Size = new System.Drawing.Size(25, 140);
            this.verticalProgressBar6.TabIndex = 1;
            this.verticalProgressBar6.Tag = "6";
            // 
            // verticalProgressBar5
            // 
            this.verticalProgressBar5.Location = new System.Drawing.Point(257, 39);
            this.verticalProgressBar5.Name = "verticalProgressBar5";
            this.verticalProgressBar5.Size = new System.Drawing.Size(25, 140);
            this.verticalProgressBar5.TabIndex = 1;
            this.verticalProgressBar5.Tag = "5";
            // 
            // verticalProgressBar4
            // 
            this.verticalProgressBar4.Location = new System.Drawing.Point(200, 39);
            this.verticalProgressBar4.Name = "verticalProgressBar4";
            this.verticalProgressBar4.Size = new System.Drawing.Size(25, 140);
            this.verticalProgressBar4.TabIndex = 1;
            this.verticalProgressBar4.Tag = "4";
            // 
            // verticalProgressBar3
            // 
            this.verticalProgressBar3.Location = new System.Drawing.Point(143, 39);
            this.verticalProgressBar3.Name = "verticalProgressBar3";
            this.verticalProgressBar3.Size = new System.Drawing.Size(25, 140);
            this.verticalProgressBar3.TabIndex = 1;
            this.verticalProgressBar3.Tag = "3";
            // 
            // verticalProgressBar2
            // 
            this.verticalProgressBar2.Location = new System.Drawing.Point(85, 39);
            this.verticalProgressBar2.Name = "verticalProgressBar2";
            this.verticalProgressBar2.Size = new System.Drawing.Size(26, 141);
            this.verticalProgressBar2.TabIndex = 1;
            this.verticalProgressBar2.Tag = "2";
            // 
            // verticalProgressBar1
            // 
            this.verticalProgressBar1.Location = new System.Drawing.Point(28, 39);
            this.verticalProgressBar1.Name = "verticalProgressBar1";
            this.verticalProgressBar1.Size = new System.Drawing.Size(25, 140);
            this.verticalProgressBar1.TabIndex = 1;
            this.verticalProgressBar1.Tag = "1";
            // 
            // gbInputSensor
            // 
            this.gbInputSensor.Controls.Add(this.pictureBox16);
            this.gbInputSensor.Controls.Add(this.pictureBox8);
            this.gbInputSensor.Controls.Add(this.pictureBox15);
            this.gbInputSensor.Controls.Add(this.pictureBox7);
            this.gbInputSensor.Controls.Add(this.pictureBox14);
            this.gbInputSensor.Controls.Add(this.pictureBox6);
            this.gbInputSensor.Controls.Add(this.pictureBox13);
            this.gbInputSensor.Controls.Add(this.pictureBox5);
            this.gbInputSensor.Controls.Add(this.pictureBox12);
            this.gbInputSensor.Controls.Add(this.pictureBox4);
            this.gbInputSensor.Controls.Add(this.pictureBox11);
            this.gbInputSensor.Controls.Add(this.pictureBox3);
            this.gbInputSensor.Controls.Add(this.pictureBox10);
            this.gbInputSensor.Controls.Add(this.pictureBox2);
            this.gbInputSensor.Controls.Add(this.pictureBox9);
            this.gbInputSensor.Controls.Add(this.label63);
            this.gbInputSensor.Controls.Add(this.label55);
            this.gbInputSensor.Controls.Add(this.label62);
            this.gbInputSensor.Controls.Add(this.label54);
            this.gbInputSensor.Controls.Add(this.label61);
            this.gbInputSensor.Controls.Add(this.label53);
            this.gbInputSensor.Controls.Add(this.label60);
            this.gbInputSensor.Controls.Add(this.label52);
            this.gbInputSensor.Controls.Add(this.label59);
            this.gbInputSensor.Controls.Add(this.label51);
            this.gbInputSensor.Controls.Add(this.label58);
            this.gbInputSensor.Controls.Add(this.label50);
            this.gbInputSensor.Controls.Add(this.label57);
            this.gbInputSensor.Controls.Add(this.label49);
            this.gbInputSensor.Controls.Add(this.label56);
            this.gbInputSensor.Controls.Add(this.label48);
            this.gbInputSensor.Controls.Add(this.pictureBox1);
            this.gbInputSensor.Location = new System.Drawing.Point(10, 441);
            this.gbInputSensor.Name = "gbInputSensor";
            this.gbInputSensor.Size = new System.Drawing.Size(950, 205);
            this.gbInputSensor.TabIndex = 0;
            this.gbInputSensor.TabStop = false;
            this.gbInputSensor.Text = "Digital Input Sensor";
            // 
            // pictureBox16
            // 
            this.pictureBox16.Image = global::ADCtrlFunc.Properties.Resources.input_off;
            this.pictureBox16.Location = new System.Drawing.Point(861, 114);
            this.pictureBox16.Name = "pictureBox16";
            this.pictureBox16.Size = new System.Drawing.Size(61, 61);
            this.pictureBox16.SizeMode = System.Windows.Forms.PictureBoxSizeMode.Zoom;
            this.pictureBox16.TabIndex = 0;
            this.pictureBox16.TabStop = false;
            this.pictureBox16.Tag = "16";
            // 
            // pictureBox8
            // 
            this.pictureBox8.Image = global::ADCtrlFunc.Properties.Resources.input_off;
            this.pictureBox8.Location = new System.Drawing.Point(861, 24);
            this.pictureBox8.Name = "pictureBox8";
            this.pictureBox8.Size = new System.Drawing.Size(61, 61);
            this.pictureBox8.SizeMode = System.Windows.Forms.PictureBoxSizeMode.Zoom;
            this.pictureBox8.TabIndex = 0;
            this.pictureBox8.TabStop = false;
            this.pictureBox8.Tag = "8";
            // 
            // pictureBox15
            // 
            this.pictureBox15.Image = global::ADCtrlFunc.Properties.Resources.input_off;
            this.pictureBox15.Location = new System.Drawing.Point(742, 114);
            this.pictureBox15.Name = "pictureBox15";
            this.pictureBox15.Size = new System.Drawing.Size(61, 61);
            this.pictureBox15.SizeMode = System.Windows.Forms.PictureBoxSizeMode.Zoom;
            this.pictureBox15.TabIndex = 0;
            this.pictureBox15.TabStop = false;
            this.pictureBox15.Tag = "15";
            // 
            // pictureBox7
            // 
            this.pictureBox7.Image = global::ADCtrlFunc.Properties.Resources.input_off;
            this.pictureBox7.Location = new System.Drawing.Point(742, 24);
            this.pictureBox7.Name = "pictureBox7";
            this.pictureBox7.Size = new System.Drawing.Size(61, 61);
            this.pictureBox7.SizeMode = System.Windows.Forms.PictureBoxSizeMode.Zoom;
            this.pictureBox7.TabIndex = 0;
            this.pictureBox7.TabStop = false;
            this.pictureBox7.Tag = "7";
            // 
            // pictureBox14
            // 
            this.pictureBox14.Image = global::ADCtrlFunc.Properties.Resources.input_off;
            this.pictureBox14.Location = new System.Drawing.Point(623, 114);
            this.pictureBox14.Name = "pictureBox14";
            this.pictureBox14.Size = new System.Drawing.Size(61, 61);
            this.pictureBox14.SizeMode = System.Windows.Forms.PictureBoxSizeMode.Zoom;
            this.pictureBox14.TabIndex = 0;
            this.pictureBox14.TabStop = false;
            this.pictureBox14.Tag = "14";
            // 
            // pictureBox6
            // 
            this.pictureBox6.Image = global::ADCtrlFunc.Properties.Resources.input_off;
            this.pictureBox6.Location = new System.Drawing.Point(623, 24);
            this.pictureBox6.Name = "pictureBox6";
            this.pictureBox6.Size = new System.Drawing.Size(61, 61);
            this.pictureBox6.SizeMode = System.Windows.Forms.PictureBoxSizeMode.Zoom;
            this.pictureBox6.TabIndex = 0;
            this.pictureBox6.TabStop = false;
            this.pictureBox6.Tag = "6";
            // 
            // pictureBox13
            // 
            this.pictureBox13.Image = global::ADCtrlFunc.Properties.Resources.input_off;
            this.pictureBox13.Location = new System.Drawing.Point(504, 114);
            this.pictureBox13.Name = "pictureBox13";
            this.pictureBox13.Size = new System.Drawing.Size(61, 61);
            this.pictureBox13.SizeMode = System.Windows.Forms.PictureBoxSizeMode.Zoom;
            this.pictureBox13.TabIndex = 0;
            this.pictureBox13.TabStop = false;
            this.pictureBox13.Tag = "13";
            // 
            // pictureBox5
            // 
            this.pictureBox5.Image = global::ADCtrlFunc.Properties.Resources.input_off;
            this.pictureBox5.Location = new System.Drawing.Point(504, 24);
            this.pictureBox5.Name = "pictureBox5";
            this.pictureBox5.Size = new System.Drawing.Size(61, 61);
            this.pictureBox5.SizeMode = System.Windows.Forms.PictureBoxSizeMode.Zoom;
            this.pictureBox5.TabIndex = 0;
            this.pictureBox5.TabStop = false;
            this.pictureBox5.Tag = "5";
            // 
            // pictureBox12
            // 
            this.pictureBox12.Image = global::ADCtrlFunc.Properties.Resources.input_off;
            this.pictureBox12.Location = new System.Drawing.Point(385, 114);
            this.pictureBox12.Name = "pictureBox12";
            this.pictureBox12.Size = new System.Drawing.Size(61, 61);
            this.pictureBox12.SizeMode = System.Windows.Forms.PictureBoxSizeMode.Zoom;
            this.pictureBox12.TabIndex = 0;
            this.pictureBox12.TabStop = false;
            this.pictureBox12.Tag = "12";
            // 
            // pictureBox4
            // 
            this.pictureBox4.Image = global::ADCtrlFunc.Properties.Resources.input_off;
            this.pictureBox4.Location = new System.Drawing.Point(385, 24);
            this.pictureBox4.Name = "pictureBox4";
            this.pictureBox4.Size = new System.Drawing.Size(61, 61);
            this.pictureBox4.SizeMode = System.Windows.Forms.PictureBoxSizeMode.Zoom;
            this.pictureBox4.TabIndex = 0;
            this.pictureBox4.TabStop = false;
            this.pictureBox4.Tag = "4";
            // 
            // pictureBox11
            // 
            this.pictureBox11.Image = global::ADCtrlFunc.Properties.Resources.input_off;
            this.pictureBox11.Location = new System.Drawing.Point(266, 114);
            this.pictureBox11.Name = "pictureBox11";
            this.pictureBox11.Size = new System.Drawing.Size(61, 61);
            this.pictureBox11.SizeMode = System.Windows.Forms.PictureBoxSizeMode.Zoom;
            this.pictureBox11.TabIndex = 0;
            this.pictureBox11.TabStop = false;
            this.pictureBox11.Tag = "11";
            // 
            // pictureBox3
            // 
            this.pictureBox3.Image = global::ADCtrlFunc.Properties.Resources.input_off;
            this.pictureBox3.Location = new System.Drawing.Point(266, 24);
            this.pictureBox3.Name = "pictureBox3";
            this.pictureBox3.Size = new System.Drawing.Size(61, 61);
            this.pictureBox3.SizeMode = System.Windows.Forms.PictureBoxSizeMode.Zoom;
            this.pictureBox3.TabIndex = 0;
            this.pictureBox3.TabStop = false;
            this.pictureBox3.Tag = "3";
            // 
            // pictureBox10
            // 
            this.pictureBox10.Image = global::ADCtrlFunc.Properties.Resources.input_off;
            this.pictureBox10.Location = new System.Drawing.Point(147, 114);
            this.pictureBox10.Name = "pictureBox10";
            this.pictureBox10.Size = new System.Drawing.Size(61, 61);
            this.pictureBox10.SizeMode = System.Windows.Forms.PictureBoxSizeMode.Zoom;
            this.pictureBox10.TabIndex = 0;
            this.pictureBox10.TabStop = false;
            this.pictureBox10.Tag = "10";
            // 
            // pictureBox2
            // 
            this.pictureBox2.Image = global::ADCtrlFunc.Properties.Resources.input_off;
            this.pictureBox2.Location = new System.Drawing.Point(147, 24);
            this.pictureBox2.Name = "pictureBox2";
            this.pictureBox2.Size = new System.Drawing.Size(61, 61);
            this.pictureBox2.SizeMode = System.Windows.Forms.PictureBoxSizeMode.Zoom;
            this.pictureBox2.TabIndex = 0;
            this.pictureBox2.TabStop = false;
            this.pictureBox2.Tag = "2";
            // 
            // pictureBox9
            // 
            this.pictureBox9.Image = global::ADCtrlFunc.Properties.Resources.input_off;
            this.pictureBox9.Location = new System.Drawing.Point(28, 114);
            this.pictureBox9.Name = "pictureBox9";
            this.pictureBox9.Size = new System.Drawing.Size(61, 61);
            this.pictureBox9.SizeMode = System.Windows.Forms.PictureBoxSizeMode.Zoom;
            this.pictureBox9.TabIndex = 0;
            this.pictureBox9.TabStop = false;
            this.pictureBox9.Tag = "9";
            // 
            // label63
            // 
            this.label63.Location = new System.Drawing.Point(854, 178);
            this.label63.Name = "label63";
            this.label63.Size = new System.Drawing.Size(72, 23);
            this.label63.TabIndex = 2;
            this.label63.Tag = "16";
            this.label63.Text = "input16";
            this.label63.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label55
            // 
            this.label55.Location = new System.Drawing.Point(857, 88);
            this.label55.Name = "label55";
            this.label55.Size = new System.Drawing.Size(72, 23);
            this.label55.TabIndex = 2;
            this.label55.Tag = "8";
            this.label55.Text = "input8";
            this.label55.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label62
            // 
            this.label62.Location = new System.Drawing.Point(735, 178);
            this.label62.Name = "label62";
            this.label62.Size = new System.Drawing.Size(72, 23);
            this.label62.TabIndex = 2;
            this.label62.Tag = "15";
            this.label62.Text = "input15";
            this.label62.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label54
            // 
            this.label54.Location = new System.Drawing.Point(738, 88);
            this.label54.Name = "label54";
            this.label54.Size = new System.Drawing.Size(72, 23);
            this.label54.TabIndex = 2;
            this.label54.Tag = "7";
            this.label54.Text = "input7";
            this.label54.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label61
            // 
            this.label61.Location = new System.Drawing.Point(616, 178);
            this.label61.Name = "label61";
            this.label61.Size = new System.Drawing.Size(72, 23);
            this.label61.TabIndex = 2;
            this.label61.Tag = "14";
            this.label61.Text = "input14";
            this.label61.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label53
            // 
            this.label53.Location = new System.Drawing.Point(619, 88);
            this.label53.Name = "label53";
            this.label53.Size = new System.Drawing.Size(72, 23);
            this.label53.TabIndex = 2;
            this.label53.Tag = "6";
            this.label53.Text = "input6";
            this.label53.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label60
            // 
            this.label60.Location = new System.Drawing.Point(497, 178);
            this.label60.Name = "label60";
            this.label60.Size = new System.Drawing.Size(72, 23);
            this.label60.TabIndex = 2;
            this.label60.Tag = "13";
            this.label60.Text = "input13";
            this.label60.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label52
            // 
            this.label52.Location = new System.Drawing.Point(500, 88);
            this.label52.Name = "label52";
            this.label52.Size = new System.Drawing.Size(72, 23);
            this.label52.TabIndex = 2;
            this.label52.Tag = "5";
            this.label52.Text = "input5";
            this.label52.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label59
            // 
            this.label59.Location = new System.Drawing.Point(378, 178);
            this.label59.Name = "label59";
            this.label59.Size = new System.Drawing.Size(72, 23);
            this.label59.TabIndex = 2;
            this.label59.Tag = "12";
            this.label59.Text = "input12";
            this.label59.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label51
            // 
            this.label51.Location = new System.Drawing.Point(381, 88);
            this.label51.Name = "label51";
            this.label51.Size = new System.Drawing.Size(72, 23);
            this.label51.TabIndex = 2;
            this.label51.Tag = "4";
            this.label51.Text = "input4";
            this.label51.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label58
            // 
            this.label58.Location = new System.Drawing.Point(259, 178);
            this.label58.Name = "label58";
            this.label58.Size = new System.Drawing.Size(72, 23);
            this.label58.TabIndex = 2;
            this.label58.Tag = "11";
            this.label58.Text = "input11";
            this.label58.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label50
            // 
            this.label50.Location = new System.Drawing.Point(262, 88);
            this.label50.Name = "label50";
            this.label50.Size = new System.Drawing.Size(72, 23);
            this.label50.TabIndex = 2;
            this.label50.Tag = "3";
            this.label50.Text = "input3";
            this.label50.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label57
            // 
            this.label57.Location = new System.Drawing.Point(140, 178);
            this.label57.Name = "label57";
            this.label57.Size = new System.Drawing.Size(72, 23);
            this.label57.TabIndex = 2;
            this.label57.Tag = "10";
            this.label57.Text = "input10";
            this.label57.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label49
            // 
            this.label49.Location = new System.Drawing.Point(143, 88);
            this.label49.Name = "label49";
            this.label49.Size = new System.Drawing.Size(72, 23);
            this.label49.TabIndex = 2;
            this.label49.Tag = "2";
            this.label49.Text = "input2";
            this.label49.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label56
            // 
            this.label56.Location = new System.Drawing.Point(21, 178);
            this.label56.Name = "label56";
            this.label56.Size = new System.Drawing.Size(72, 23);
            this.label56.TabIndex = 2;
            this.label56.Tag = "9";
            this.label56.Text = "input9";
            this.label56.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label48
            // 
            this.label48.Location = new System.Drawing.Point(24, 88);
            this.label48.Name = "label48";
            this.label48.Size = new System.Drawing.Size(72, 23);
            this.label48.TabIndex = 2;
            this.label48.Tag = "1";
            this.label48.Text = "input1";
            this.label48.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // pictureBox1
            // 
            this.pictureBox1.Image = global::ADCtrlFunc.Properties.Resources.input_off;
            this.pictureBox1.Location = new System.Drawing.Point(28, 24);
            this.pictureBox1.Name = "pictureBox1";
            this.pictureBox1.Size = new System.Drawing.Size(61, 61);
            this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.Zoom;
            this.pictureBox1.TabIndex = 0;
            this.pictureBox1.TabStop = false;
            this.pictureBox1.Tag = "1";
            // 
            // gbTempSensor
            // 
            this.gbTempSensor.Controls.Add(this.chkCF);
            this.gbTempSensor.Controls.Add(this.verticalProgressBar21);
            this.gbTempSensor.Controls.Add(this.verticalProgressBar19);
            this.gbTempSensor.Controls.Add(this.verticalProgressBar20);
            this.gbTempSensor.Controls.Add(this.verticalProgressBar17);
            this.gbTempSensor.Controls.Add(this.verticalProgressBar18);
            this.gbTempSensor.Controls.Add(this.label68);
            this.gbTempSensor.Controls.Add(this.label64);
            this.gbTempSensor.Controls.Add(this.label65);
            this.gbTempSensor.Controls.Add(this.label67);
            this.gbTempSensor.Controls.Add(this.label66);
            this.gbTempSensor.Controls.Add(this.label71);
            this.gbTempSensor.Controls.Add(this.label69);
            this.gbTempSensor.Controls.Add(this.label70);
            this.gbTempSensor.Controls.Add(this.label72);
            this.gbTempSensor.Controls.Add(this.label73);
            this.gbTempSensor.Location = new System.Drawing.Point(10, 243);
            this.gbTempSensor.Name = "gbTempSensor";
            this.gbTempSensor.Size = new System.Drawing.Size(664, 192);
            this.gbTempSensor.TabIndex = 1;
            this.gbTempSensor.TabStop = false;
            this.gbTempSensor.Text = "Temperature Sensor";
            // 
            // chkCF
            // 
            this.chkCF.AutoSize = true;
            this.chkCF.Location = new System.Drawing.Point(533, 160);
            this.chkCF.Name = "chkCF";
            this.chkCF.Size = new System.Drawing.Size(116, 19);
            this.chkCF.TabIndex = 3;
            this.chkCF.Text = "°F Display";
            this.chkCF.UseVisualStyleBackColor = true;
            this.chkCF.CheckedChanged += new System.EventHandler(this.chkCF_CheckedChanged);
            // 
            // verticalProgressBar21
            // 
            this.verticalProgressBar21.Location = new System.Drawing.Point(469, 41);
            this.verticalProgressBar21.Name = "verticalProgressBar21";
            this.verticalProgressBar21.Size = new System.Drawing.Size(25, 114);
            this.verticalProgressBar21.TabIndex = 1;
            this.verticalProgressBar21.Tag = "5";
            // 
            // verticalProgressBar19
            // 
            this.verticalProgressBar19.Location = new System.Drawing.Point(249, 40);
            this.verticalProgressBar19.Name = "verticalProgressBar19";
            this.verticalProgressBar19.Size = new System.Drawing.Size(25, 115);
            this.verticalProgressBar19.TabIndex = 1;
            this.verticalProgressBar19.Tag = "3";
            // 
            // verticalProgressBar20
            // 
            this.verticalProgressBar20.Location = new System.Drawing.Point(359, 41);
            this.verticalProgressBar20.Name = "verticalProgressBar20";
            this.verticalProgressBar20.Size = new System.Drawing.Size(25, 114);
            this.verticalProgressBar20.TabIndex = 1;
            this.verticalProgressBar20.Tag = "4";
            // 
            // verticalProgressBar17
            // 
            this.verticalProgressBar17.Location = new System.Drawing.Point(28, 40);
            this.verticalProgressBar17.Name = "verticalProgressBar17";
            this.verticalProgressBar17.Size = new System.Drawing.Size(25, 115);
            this.verticalProgressBar17.TabIndex = 1;
            this.verticalProgressBar17.Tag = "1";
            // 
            // verticalProgressBar18
            // 
            this.verticalProgressBar18.Location = new System.Drawing.Point(138, 40);
            this.verticalProgressBar18.Name = "verticalProgressBar18";
            this.verticalProgressBar18.Size = new System.Drawing.Size(26, 115);
            this.verticalProgressBar18.TabIndex = 1;
            this.verticalProgressBar18.Tag = "2";
            // 
            // label68
            // 
            this.label68.Location = new System.Drawing.Point(354, 162);
            this.label68.Name = "label68";
            this.label68.Size = new System.Drawing.Size(39, 15);
            this.label68.TabIndex = 2;
            this.label68.Tag = "4";
            this.label68.Text = "0.00";
            this.label68.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label64
            // 
            this.label64.Location = new System.Drawing.Point(21, 161);
            this.label64.Name = "label64";
            this.label64.Size = new System.Drawing.Size(39, 15);
            this.label64.TabIndex = 2;
            this.label64.Tag = "1";
            this.label64.Text = "0.00";
            this.label64.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label65
            // 
            this.label65.Location = new System.Drawing.Point(132, 161);
            this.label65.Name = "label65";
            this.label65.Size = new System.Drawing.Size(39, 15);
            this.label65.TabIndex = 2;
            this.label65.Tag = "2";
            this.label65.Text = "0.00";
            this.label65.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label67
            // 
            this.label67.Location = new System.Drawing.Point(465, 162);
            this.label67.Name = "label67";
            this.label67.Size = new System.Drawing.Size(39, 15);
            this.label67.TabIndex = 2;
            this.label67.Tag = "5";
            this.label67.Text = "0.00";
            this.label67.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // label66
            // 
            this.label66.Location = new System.Drawing.Point(243, 161);
            this.label66.Name = "label66";
            this.label66.Size = new System.Drawing.Size(39, 15);
            this.label66.TabIndex = 2;
            this.label66.Tag = "3";
            this.label66.Text = "0.00";
            this.label66.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // gbCmd
            // 
            this.gbCmd.Controls.Add(this.btnChange);
            this.gbCmd.Controls.Add(this.btnAutoReport);
            this.gbCmd.Controls.Add(this.chkTmr);
            this.gbCmd.Location = new System.Drawing.Point(680, 243);
            this.gbCmd.Name = "gbCmd";
            this.gbCmd.Size = new System.Drawing.Size(280, 192);
            this.gbCmd.TabIndex = 2;
            this.gbCmd.TabStop = false;
            // 
            // btnAutoReport
            // 
            this.btnAutoReport.Location = new System.Drawing.Point(10, 55);
            this.btnAutoReport.Name = "btnAutoReport";
            this.btnAutoReport.Size = new System.Drawing.Size(130, 121);
            this.btnAutoReport.TabIndex = 2;
            this.btnAutoReport.Text = "AutoReport ON";
            this.btnAutoReport.UseVisualStyleBackColor = true;
            this.btnAutoReport.Click += new System.EventHandler(this.btnAutoReport_Click);
            // 
            // chkTmr
            // 
            this.chkTmr.AutoSize = true;
            this.chkTmr.Location = new System.Drawing.Point(13, 21);
            this.chkTmr.Name = "chkTmr";
            this.chkTmr.Size = new System.Drawing.Size(117, 19);
            this.chkTmr.TabIndex = 1;
            this.chkTmr.Text = "AutoRefresh";
            this.chkTmr.UseVisualStyleBackColor = true;
            this.chkTmr.CheckedChanged += new System.EventHandler(this.chkTmr_CheckedChanged);
            // 
            // btnConnect
            // 
            this.btnConnect.Location = new System.Drawing.Point(486, 652);
            this.btnConnect.Name = "btnConnect";
            this.btnConnect.Size = new System.Drawing.Size(474, 55);
            this.btnConnect.TabIndex = 0;
            this.btnConnect.Text = "Connect";
            this.btnConnect.UseVisualStyleBackColor = true;
            this.btnConnect.Click += new System.EventHandler(this.btnConnect_Click);
            // 
            // btnRemove
            // 
            this.btnRemove.Location = new System.Drawing.Point(10, 652);
            this.btnRemove.Name = "btnRemove";
            this.btnRemove.Size = new System.Drawing.Size(472, 55);
            this.btnRemove.TabIndex = 0;
            this.btnRemove.Text = "Remove";
            this.btnRemove.UseVisualStyleBackColor = true;
            this.btnRemove.Click += new System.EventHandler(this.btnRemove_Click);
            // 
            // label72
            // 
            this.label72.Location = new System.Drawing.Point(451, 21);
            this.label72.Name = "label72";
            this.label72.Size = new System.Drawing.Size(60, 15);
            this.label72.TabIndex = 2;
            this.label72.Tag = "45";
            this.label72.Text = "5";
            this.label72.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // label73
            // 
            this.label73.Location = new System.Drawing.Point(341, 21);
            this.label73.Name = "label73";
            this.label73.Size = new System.Drawing.Size(60, 15);
            this.label73.TabIndex = 2;
            this.label73.Tag = "44";
            this.label73.Text = "4";
            this.label73.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // label71
            // 
            this.label71.Location = new System.Drawing.Point(231, 21);
            this.label71.Name = "label71";
            this.label71.Size = new System.Drawing.Size(60, 15);
            this.label71.TabIndex = 2;
            this.label71.Tag = "43";
            this.label71.Text = "3";
            this.label71.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // label70
            // 
            this.label70.Location = new System.Drawing.Point(121, 21);
            this.label70.Name = "label70";
            this.label70.Size = new System.Drawing.Size(60, 15);
            this.label70.TabIndex = 2;
            this.label70.Tag = "42";
            this.label70.Text = "2";
            this.label70.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // label69
            // 
            this.label69.Location = new System.Drawing.Point(10, 21);
            this.label69.Name = "label69";
            this.label69.Size = new System.Drawing.Size(60, 15);
            this.label69.TabIndex = 2;
            this.label69.Tag = "41";
            this.label69.Text = "1";
            this.label69.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // btnChange
            // 
            this.btnChange.Location = new System.Drawing.Point(150, 55);
            this.btnChange.Name = "btnChange";
            this.btnChange.Size = new System.Drawing.Size(130, 121);
            this.btnChange.TabIndex = 2;
            this.btnChange.Text = "Change Text";
            this.btnChange.UseVisualStyleBackColor = true;
            this.btnChange.Click += new System.EventHandler(this.btnChange_Click);
            // 
            // ADCtrlBoard
            // 
            this.Controls.Add(this.gbCmd);
            this.Controls.Add(this.gbTempSensor);
            this.Controls.Add(this.btnConnect);
            this.Controls.Add(this.gbInputSensor);
            this.Controls.Add(this.btnRemove);
            this.Controls.Add(this.gbAnalogSensor);
            this.Name = "ADCtrlBoard";
            this.Size = new System.Drawing.Size(971, 710);
            this.Load += new System.EventHandler(this.ADCtrlBoard_Load);
            this.gbAnalogSensor.ResumeLayout(false);
            this.gbInputSensor.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox16)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox8)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox15)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox7)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox14)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox6)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox13)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox5)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox12)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox4)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox11)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox3)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox10)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox2)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox9)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).EndInit();
            this.gbTempSensor.ResumeLayout(false);
            this.gbTempSensor.PerformLayout();
            this.gbCmd.ResumeLayout(false);
            this.gbCmd.PerformLayout();
            this.ResumeLayout(false);

        }

        #endregion

        /// <summary>
        /// 必需的设计器变量。
        /// </summary>
        private System.ComponentModel.IContainer components = null;


        public ADCtrlBoard()
        {
            InitializeComponent();
            initClient();
            ad_text = AdText.GetAdText(client_ip);
            ad_text = new AdText();
        } 
        protected override void Dispose(bool disposing)
        {
            
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        private void ADCtrlBoard_Load(object sender, EventArgs e)
        {
            //this.Width = gbAnalogSensor.Width + 20;// + gbTempSensor.Width;
            //this.Height = gbAnalogSensor.Height + gbInputSensor.Height + gbCmd.Height+60;

            initClient();

            ad_text = AdText.GetAdText(client_ip);

            AdText.SetAdText($"{client_ip}", gbAnalogSensor, gbTempSensor, gbInputSensor);
            string iniFile = $"{Application.StartupPath}\\Settings\\{client_ip}.ini";
            string unit_str = IniHelper.INIGetStringValue(iniFile, "TemperatureProp", "DisplayUnit", "C");
            if (unit_str == "F") 
                chkCF.Checked = true;

            

        }

        /// <summary>
        /// LOG
        /// </summary>
        /// <param name="log"></param>
        public delegate void AddLogHandlerDelegate(string log);
        public static event AddLogHandlerDelegate AddLogEvent;
        //delegate void AddLogHandler(string log);
        private void AddLog(string log)
        {
            if (AddLogEvent != null)
                AddLogEvent(log);
        }
         
        /// <summary>
        /// CLIENT PROPERITY
        /// </summary>
        public string ClientIp
        {
            get { return client_ip; }
            set { client_ip = value; }
        }

        public string ClientName
        {
            get { return client_name; }
            set { client_name = value; }
        }

        public ushort ClientPort
        {
            get { return client_port; }
            set { client_port = value; }
        }
        public int ClientTag
        {
            get { return client_tag; }
            set { client_tag = value; }
        }

        private string file_path = "";

        public string ClientFileSavePath
        {
            get { return file_path; }
            set { file_path = value; }
        }

#pragma warning disable IDE0069 // 应释放可释放的字段
        private readonly ITcpClient _client = new TcpClient();
#pragma warning restore IDE0069 // 应释放可释放的字段

        /// <summary>
        /// 封包, 做粘包用
        /// </summary>
        private readonly List<byte> _packetData = new List<byte>();
        private string client_ip { get; set; }
        private ushort client_port { get; set; }
        private int client_tag { get; set; }
        private bool isConnectSocket { get; set; }
        private string CmdStr { get; set; }
        private string client_name { get; set; }
        private Timer client_tmr { get; set; }

        public bool isConnectStatus
        {
            get { return isConnectSocket || _client.HasStarted; }
        }

        /// <summary>
        /// 最大封包长度
        /// </summary>
        private const int MaxPacketSize = 4096;

        /// <summary>
        /// 封包头长度
        /// </summary>
        private const int PacketHeadLength = 44;

        private static string iniFilePath = Application.StartupPath + @"\cfg.ini";

        private void initClient()
        {
            ///CLIENT SETTING
            _client.SocketBufferSize = 4096; // 4K
            _client.Tag = client_tag;
            _client.Async = true; // 异步连接
            // 要连接的服务器地址和端口(也可以调用Connect()方法时传入服务器ip和端口)
            // 例如: _client.Connect("127.0.0.1", 555)
            _client.Address = client_ip == null ? "127.0.0.1" : client_ip;
            _client.Port = client_port == 0 ? (ushort)4197 : client_port;

            // 事件绑定
            _client.OnPrepareConnect += OnPrepareConnect;
            _client.OnConnect += OnConnect;
            _client.OnReceive += OnReceive;
            _client.OnClose += OnClose;

            client_tmr = new Timer();
            client_tmr.Interval = 300;
            client_tmr.Tick += Client_tmr_Tick;
        }
        static int cnt_client_tmr = 0;
        private void Client_tmr_Tick(object sender, EventArgs e)
        {
            cnt_client_tmr++; 
            if(cnt_client_tmr %3 == 0)
                Send(PacketType.ReadAnalogCmd, new byte[1] { 0xff }, client_tag);
            else if (cnt_client_tmr % 3 == 1)
                Send(PacketType.ReadTemperatureCmd, new byte[1] { 0xff }, client_tag);
            else if (cnt_client_tmr % 3 == 2)
                Send(PacketType.ReadSwitchCmd, new byte[1] { 0xff }, client_tag);
            if (cnt_client_tmr > 100000) cnt_client_tmr = 0;
            //throw new NotImplementedException(); 

        }

        // ReSharper disable once InconsistentNaming
        private HandleResult OnPrepareConnect(IClient sender, IntPtr socket)
        {
            int channel = Convert.ToInt32(sender.Tag) - 100;
            AddLog($"ADC Socket{channel} OnPrepareConnect({sender.Address}:{sender.Port}), socket handle: {socket}");
            //ItemStatusChange(new ItemProp(client_ip,client_port,client_tag,
            //    ITEM_STATUS_ENUM.ON_PREPARE_CONNECT,ITEM_BELONG_ENUM.AD_BOARD));
            return HandleResult.Ok;
        }

        // ReSharper disable once InconsistentNaming
        private HandleResult OnConnect(IClient sender)
        {
            int channel = Convert.ToInt32(sender.Tag) - 100;
            AddLog($"ADC Socket{channel} OnConnect()");
            ItemStatusChange(new ItemProp(client_ip, client_port, client_tag,
                ITEM_STATUS_ENUM.ON_CONNECT, ITEM_BELONG_ENUM.AD_BOARD));
            this.Invoke(new EventHandler(delegate
            {
                //lblConnStatus.Text = "Connect success,wait for more operation...";
                //dt_record_run = DateTime.Now;
                //client_tmr.Start();
            })); 

            _packetData.Clear();
            return HandleResult.Ok;
        }

        // ReSharper disable once InconsistentNaming
        private HandleResult OnReceive(IClient sender, byte[] data)
        {
            int channel = Convert.ToInt32(sender.Tag) - 100;
            AddLog($"ADC Socket{channel} OnReceive(), data length: {data.Length},<Display ASCII:{ASCIIEncoding.ASCII.GetString(data)}>");

            _packetData.AddRange(data);


            HandleResult result;
            const int headerLength = PacketHeadLength;
            do
            {
                // 总长度小于包头
                if (_packetData.Count < PacketHeadLength)
                {
                    return HandleResult.Ok;
                }

                // 取头部字节得到包头
                var packetHeader = _packetData.GetRange(0, headerLength).ToArray();

                // 得到包头指向的命令类型
                var cmdType = (PacketType)BitConverter.ToUInt16(packetHeader, 2);

                // 得到包头指向的数据长度
                var dataLength = BitConverter.ToUInt16(packetHeader, 4);

                // 完整的包长度(含包头和完整数据的大小)
                var fullLength = dataLength + headerLength;

                ///检查帧长度
                if (dataLength < 0 || fullLength > MaxPacketSize)
                {
                    result = HandleResult.Error;
                    break;
                }

                // 如果来的数据小于一个完整的包
                if (_packetData.Count < PacketHeadLength)
                {
                    // 下次数据到达处理
                    // 清空缓存
                    _packetData.Clear();
                    result = HandleResult.Ignore;
                    break;
                }
                // 是不是一个完整的包(包长 = 实际数据长度 + 包头长度)
                if (_packetData.Count == fullLength)
                {
                    // 得到完整包并处理
                    //var fullData = _packetData.GetRange(headerLength, dataLength).ToArray();
                    //result = OnProcessFullPacket(fullData);
                    Packet rcv_packet = ParsePacket(_packetData.ToArray());
                    result = OnProcessFullPacket(rcv_packet);
                    // 清空缓存
                    _packetData.Clear();
                    break;
                } 
                // 如果来的数据比一个完整的包长
                else if (_packetData.Count > fullLength)
                {
                    // 先得到完整包并处理
                    //var fullData = _packetData.GetRange(headerLength, dataLength).ToArray();
                    //result = OnProcessFullPacket(fullData);
                    Packet rcv_packet = ParsePacket(_packetData.ToArray());
                    result = OnProcessFullPacket(rcv_packet);
                    if (result == HandleResult.Error)
                    {
                        break;
                    }
                    // 再移除已经读了的数据
                    // _packetData.RemoveRange(0, fullLength);

                    // 清空缓存
                    _packetData.Clear();
                    result = HandleResult.Ignore;
                    break;
                    // 剩余的数据下个循环处理
                }
                else if (_packetData.Count < fullLength)
                {
                    // 清空缓存
                    _packetData.Clear();
                    result = HandleResult.Ignore;
                    break;
                }


            } while (true);


            return result;
        }

        // ReSharper disable once InconsistentNaming
        private HandleResult OnClose(IClient sender, SocketOperation socketOperation, int errorCode)
        {
            Int32 channel = Convert.ToInt32(sender.Tag) - 100;
            _packetData.Clear();
            AddLog($"Socket{channel} OnClose(), socket operation: {socketOperation}, error code: {errorCode}");
            ItemStatusChange(new ItemProp(client_ip, client_port, client_tag,
                ITEM_STATUS_ENUM.ON_CLOSE, ITEM_BELONG_ENUM.AD_BOARD));
            //if (errorCode != 0)
            //{

            //}

            this.Invoke(new EventHandler(delegate
            {
                //BtnConnectSwitch_Click(null, null);
                isConnectSocket = false;
                btnConnect.Text = "Connect";
                btnConnect.BackColor = DefaultBackColor;
                client_tmr.Stop();
                //btnSave.Enabled = true;
                //btnLoadFile.Enabled = true;

            }));



            return HandleResult.Ok;
        }

        public delegate void InputChangeHandlerDelegate(string ip,byte[] data);
        public static event InputChangeHandlerDelegate InputChangeEvent;
        private void InputChangeEvt(string ip, byte[] data)
        {
            if (InputChangeEvent != null)
                InputChangeEvent(ip,data);
        }

        // ReSharper disable once InconsistentNaming
        private HandleResult OnProcessFullPacket(Packet rcv_packet)
        {
            // 这里来的都是完整的包 
            var result = HandleResult.Ok;
            switch (rcv_packet.Type)
            {
                case PacketType.AutoReportInputCmd:
                    {
                        AddLog($"OnProcessFullPacket(), Type: {rcv_packet.Type}, Content: {ByteToHexStr(rcv_packet.Data)}");
                        ParseReadIoLogic(rcv_packet.Data);
                        //InputChangeEvt(_client.Address, rcv_packet.Data);
                        break;
                    }
                case PacketType.AutoReportAnalogyCmd:
                    {
                        AddLog($"OnProcessFullPacket(), Type: {rcv_packet.Type}, Content: {ByteToHexStr(rcv_packet.Data)}");
                        ParseReadAnalogLogic(rcv_packet.Data);
                        break;
                    }
                case PacketType.AutoReportTempCmd:
                    {
                        AddLog($"OnProcessFullPacket(), Type: {rcv_packet.Type}, Content: {ByteToHexStr(rcv_packet.Data)}");
                        ParseReadTempLogic(rcv_packet.Data);
                        break;
                    }
                case PacketType.ReadSwitchCmd: // 读取开关量命令
                    {
                        AddLog($"OnProcessFullPacket(), Type: {rcv_packet.Type}, Content: {ByteToHexStr(rcv_packet.Data)}");
                        ParseReadIoLogic(rcv_packet.Data);
                        
                        //InputChangeEvt(_client.Address, rcv_packet.Data);
                        break;
                    }
                case PacketType.ReadAnalogCmd: // 读取模拟量命令
                    {
                        AddLog($"OnProcessFullPacket(), Type: {rcv_packet.Type}, Content: {ByteToHexStr(rcv_packet.Data)}");
                        ParseReadAnalogLogic(rcv_packet.Data);
                        break;
                    }
                case PacketType.ReadTemperatureCmd: // 读取温度值命令
                    {
                        AddLog($"OnProcessFullPacket(), Type: {rcv_packet.Type}, Content: {ByteToHexStr(rcv_packet.Data)}");
                        ParseReadTempLogic(rcv_packet.Data);
                        break;
                    }
                case PacketType.ReadMainboardParamCmd: // 读主板配置参数命令
                    {
                        AddLog($"OnProcessFullPacket(), Type: {rcv_packet.Type}, Content: {ByteToHexStr(rcv_packet.Data)}");
                        ParseReadMainboardParamLogic(rcv_packet.Data);
                        break;
                    }
                case PacketType.AutoReportOnoffCmd: // 开启/关闭自动上报命令
                    {
                        AddLog($"OnProcessFullPacket(), Type: {rcv_packet.Type}, Content: {ByteToHexStr(rcv_packet.Data)}");
                        bFlagAutoReportOnoff = !bFlagAutoReportOnoff;
                        ParseOnoffAutoReportLogic();
                        break;
                    }
                //default:result = HandleResult.Ignore;break;
                default: break;
            }
            return result;
        }

        /// <summary>
        /// 发送数据
        /// </summary>
        /// <param name="type"></param>
        /// <param name="data"></param>
        private void Send(PacketType type, byte[] content, Int32 tag)
        {
            if (!_client.HasStarted)
            {
                return;
            }

            var packet = new Packet();

            if (content != null)
            {
                // 组织封包, 取得要发送的数据
                packet.Header = JkePacketHeader;
                packet.Type = type;
                packet.Data = content;
                packet.DataLen = (UInt16)content.Length;
            }
            else
            {
                // 组织封包, 取得要发送的数据
                packet.Header = JkePacketHeader;
                packet.Type = type;
                packet.Data = null;
                packet.DataLen = 0;
            }

            var bytes = AssemblePacket(packet);
            // 发送实际数据, 发送失败断开连接
            if (!_client.Send(bytes, bytes.Length))
            {
                _client.Stop();
            }
            else
            {
                string send_str = $"Send {type}:";
                List<byte> tmp_list = new List<byte>();
                for (int i = 0; i < bytes.Length; i++) { send_str += bytes[i].ToString("X2") + " "; tmp_list.Add(bytes[i]); }
                tmp_list.RemoveRange(0, 44);
                tmp_list.Remove(0);
                send_str += $"  <Display Ascii Content: \"{System.Text.Encoding.ASCII.GetString(tmp_list.ToArray())}\">";//(bytes.Skip(44).Take(bytes.Length-44).ToArray())
                AddLog(send_str);
            }
        }
        static void Delay(uint ms)
        {
            uint start = GetTickCount();
            while (GetTickCount() - start < ms)
            {
                System.Windows.Forms.Application.DoEvents();
            }
        }

        public async void ConnectServer()
        {

            try
            {
                if (!isConnectSocket)
                {
                    // 连接到目标服务器
                    if (!_client.Connect())
                    {
                        isConnectSocket = false;
                        btnConnect.Text = "Connected";
                        btnConnect.BackColor = DefaultBackColor;
                        throw new Exception($"error code: {_client.ErrorCode}, error message: {_client.ErrorMessage}");
                    }
                    else
                    {
                        isConnectSocket = true;
                        btnConnect.Text = "Close";
                        btnConnect.BackColor = Color.Green;
                        await _client.WaitAsync();

                        Delay(500);
                        Send(PacketType.ReadMainboardParamCmd, null,client_tag);
                    }
                }
                else
                {
                    // 断开连接 // 等待服务停止
                    //Send(RlyMsgType.H32_CONTROL_MULITI, RlyMsgCmd.H32ControlMulitiChannel(0), client_tag);
                    System.Threading.Thread.Sleep(200);
                    await _client.StopAsync();
                    isConnectSocket = false;

                    btnConnect.Text = "Connect";
                    btnConnect.BackColor = DefaultBackColor;
                }

            }
            catch (Exception ex)
            {
                isConnectSocket = false;
                btnConnect.Text = "Connect";
                btnConnect.BackColor = DefaultBackColor;
                AddLog($"Connect exception: {ex.Message}");
            }
        }

        public delegate void ClosemeHandlerDelegate(string log);
        public event ClosemeHandlerDelegate ClosemeEvent;
        //delegate void AddLogHandler(string log);
        private void Closeme(string connection)
        {
            if (ClosemeEvent != null)
                ClosemeEvent(connection);
        }

        private void btnRun_Click(object sender, EventArgs e)
        {

            ConnectServer();

            if (isConnectSocket && _client.HasStarted)
            {

            }
            else
            {

            }
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            if (isConnectStatus) btnRun_Click(null, null);
            System.Threading.Thread.Sleep(100);

            Closeme($"{client_ip}:{client_port}");
        }

        #region ADC MESSAGE DEFINE
        /// <summary>
        /// 封包类型
        /// </summary>
        public enum PacketType
        {
            /// <summary>
            /// 继电器板透传命令
            /// </summary>
            RelayTransportCmd = 0xC001,
            /// <summary>
            /// RS232透传命令
            /// </summary>
            RS232TransportCmd = 0xC002,
            /// <summary>
            /// RS485透传命令
            /// </summary>
            RS485TransportCmd = 0xC003,
            /// <summary>
            /// IFTTT功能配置命令
            /// </summary>
            IftttConfigCmd = 0xC011,
            /// <summary>
            /// 上位机下载自定义命令
            /// </summary>
            WritePcDownloadUsrCmd = 0xC012,
            /// <summary>
            /// 上位机下载自定义命令
            /// </summary>
            DeleteIftttCfg = 0xC013,
            /// <summary>
            /// 上位机下载自定义命令
            /// </summary>
            DeleteUsrDefCmd = 0xC014,
            /// <summary>
            /// 读取IFTTT功能配置命令
            /// </summary>
            ReadIftttConfigCmd = 0xC021,
            /// <summary>
            /// 读取上位机下载自定义内容命令
            /// </summary>
            ReadPcDownloadUsrCmd = 0xC022,
            /// <summary>
            /// 读取开关量命令
            /// </summary>
            ReadSwitchCmd = 0xC023,
            /// <summary>
            /// 读取模拟量命令
            /// </summary>
            ReadAnalogCmd = 0xC024,
            /// <summary>
            /// 读取温度值命令
            /// </summary>
            ReadTemperatureCmd = 0xC025,
            /// <summary>
            /// 读取IFTTT当前执行状态的命令
            /// </summary>
            ReadIftttCurrentExcuteStatusCmd = 0xC026,
            /// <summary>
            /// 主控板参数设置命令
            /// </summary>
            WriteMainboardParamSetup = 0xC031,
            /// <summary>
            /// 时间同步命令
            /// </summary>
            SyncTimeCmd = 0xC032,
            /// <summary>
            /// 开启/关闭自动上报命令
            /// </summary>
            AutoReportOnoffCmd = 0xC033,
            /// <summary>
            /// 读主板参数命令
            /// </summary>
            ReadMainboardParamCmd = 0xC034,
            /// <summary>
            /// 开关量自动上报命令
            /// </summary>
            AutoReportInputCmd = 0xC041,
            /// <summary>
            /// 开关量自动上报命令
            /// </summary>
            AutoReportAnalogyCmd = 0xC042,
            /// <summary>
            /// 开关量自动上报命令
            /// </summary>
            AutoReportTempCmd = 0xC043,

        }
        public static PacketHeader JkePacketHeader = new PacketHeader
        {
            MarkBit = 0x5E,
            VersionBit = 0x01,
        };
        /// <summary>
        /// 封包
        /// </summary>
        public class Packet
        {
            /// <summary>
            /// 封包头
            /// </summary>
            public PacketHeader Header { get; set; }

            /// <summary>
            /// 封包类型
            /// </summary>
            public PacketType Type { get; set; }

            /// <summary>
            /// 数据
            /// </summary>
            public byte[] Data { get; set; }

            public UInt16 DataLen { get; set; }
        }

        public class PacketHeader
        {
            public Byte MarkBit { get; set; }
            public Byte VersionBit { get; set; }
            public PacketType Type { get; set; }
            public UInt16 DataLen { get; set; }
            public Byte[] DeviceID { get; set; }
            public Byte[] ExtendData { get; set; }
            public PacketHeader()
            {
                DeviceID = new Byte[28];
                ExtendData = new Byte[10];
            }
        }

        private Byte[] AssemblePacket(Packet pack_in)
        {
            Byte[] send_buf = new Byte[PacketHeadLength + pack_in.DataLen];

            send_buf[0] = pack_in.Header.MarkBit;
            send_buf[1] = pack_in.Header.VersionBit;
            send_buf[2] = (Byte)((UInt16)pack_in.Type & 0x0ff);
            send_buf[3] = (Byte)((UInt16)pack_in.Type >> 8);
            send_buf[4] = (Byte)(pack_in.DataLen & 0x0ff);
            send_buf[5] = (Byte)(pack_in.DataLen >> 8);
            Array.Copy(pack_in.Header.DeviceID, 0, send_buf, 6, pack_in.Header.DeviceID.Length);
            Array.Copy(pack_in.Header.ExtendData, 0, send_buf, 34, pack_in.Header.ExtendData.Length);
            if (pack_in.DataLen != 0)
                Array.Copy(pack_in.Data, 0, send_buf, PacketHeadLength, pack_in.DataLen);

            return send_buf;
        }
        /// <summary>
        /// ParsePacket
        /// </summary>
        /// <param name="data"></param>
        /// <returns></returns>
        private Packet ParsePacket(byte[] data)
        {
            if (data.Length < PacketHeadLength) return null;

            Packet rcv_pack = new Packet();
            PacketHeader rcv_ph = new PacketHeader();
            rcv_ph.MarkBit = data[0];
            rcv_ph.VersionBit = data[1];
            rcv_ph.Type = (PacketType)(data[3] << 8 | data[2]);
            rcv_ph.DataLen = (UInt16)(data[5] << 8 | data[4]);
            Array.Copy(data, 6, rcv_ph.DeviceID, 0, rcv_ph.DeviceID.Length);
            Array.Copy(data, 34, rcv_ph.ExtendData, 0, rcv_ph.ExtendData.Length);
            rcv_pack.Header = rcv_ph;
            rcv_pack.Type = rcv_ph.Type;
            rcv_pack.DataLen = rcv_ph.DataLen;
            rcv_pack.Data = new Byte[rcv_pack.DataLen];
            Array.Copy(data, PacketHeadLength, rcv_pack.Data, 0, rcv_ph.DataLen);
            return rcv_pack;
        }
        /// <summary>
        /// 字节数组转16进制字符串
        /// </summary>
        /// <param name="bytes"></param>
        /// <returns></returns>
        public static string ByteToHexStr(byte[] bytes)
        {
            string returnStr = "";
            if (bytes != null)
            {
                for (int i = 0; i < bytes.Length; i++)
                {
                    returnStr += bytes[i].ToString("X2") + " ";
                }
            }
            return returnStr;
        }

        /// <summary>
        /// 字符串转16进制字节数组
        /// </summary>
        /// <param name="hexString"></param>
        /// <returns></returns>
        public static byte[] HexstrToToByteArr(string hexString)
        {
            hexString = hexString.Replace(" ", "");
            hexString = hexString.Replace(",", "");
            if ((hexString.Length % 2) != 0)
                hexString += " ";
            byte[] returnBytes = new byte[hexString.Length / 2];
            try
            {
                for (int i = 0; i < returnBytes.Length; i++)
                    returnBytes[i] = Convert.ToByte(hexString.Substring(i * 2, 2), 16);
            }
            catch
            {
                return null;
            }
            return returnBytes;
        }
        private void WriteDataToFile(int input_index,bool current_state)
        {
            string file_path_save = Application.StartupPath + $"\\LogData\\{_client.Address}\\";
            if(!Directory.Exists(file_path_save))
            {
                Directory.CreateDirectory(file_path_save);
            }
            DateTime dt_save = DateTime.Now;
            file_path_save += $"Log_{dt_save.Year}_{dt_save.Month}_{dt_save.Day}_InputStateChange.txt";
            if (!File.Exists(file_path_save))
            {
                File.Create(file_path_save).Close();
            }
            //using (FileStream fs = new FileStream(file_path_save, FileMode.Append, FileAccess.Write))
            //{
            //    string write_str = $"[{dt_save.ToString("yyyy/MM/dd HH:mm:dd:fff")}]>>>";
            //    string status = current_state? "on" : "off";
            //    write_str += $"{_client.Address},Input ID = {input_index+1} Change, Current Status={status}";
            //    byte[] buffer = Encoding.Default.GetBytes(write_str);
            //    fs.Write(buffer, 0, buffer.Length);
            //    fs.Close();
            //}
            FileStream fs = new FileStream(file_path_save, FileMode.Append, FileAccess.Write);
            StreamWriter sw = new StreamWriter(fs, Encoding.UTF8);

            string write_str = $"[{dt_save.ToString("yyyy/MM/dd HH:mm:dd:fff")}]>>>";
            string status = current_state ? "on" : "off";
            write_str += $"{_client.Address},Input ID = {input_index + 1} Change, Current Status={status}";


            sw.WriteLine(write_str);

            sw.Close();
            fs.Close();
        }

        private void ParseReadIoLogic(byte[] data)
        {
            this.Invoke(new EventHandler(delegate
            {
                foreach (Control ctrl in gbInputSensor.Controls)
                {
                    if (ctrl is PictureBox)
                    {
                        if (data.Length == 2)
                        {
                            
                            if (Convert.ToInt32(((PictureBox)ctrl).Tag) == data[0])
                            {
                                ((PictureBox)ctrl).Image = (data[1] == 0x00) ? Properties.Resources.input_off : Properties.Resources.input_on;

                                ad_input_states_arr[Convert.ToInt32(((PictureBox)ctrl).Tag) - 1] = (data[1] == 0) ? false : true;
                            }
                        }
                        else if (data.Length == 17)
                        {
                            if (0xff == data[0])
                            {
                                ((PictureBox)ctrl).Image = (data[Convert.ToInt32(((PictureBox)ctrl).Tag)] == 0x00) ? Properties.Resources.input_off : Properties.Resources.input_on;
                                ad_input_states_arr[Convert.ToInt32(((PictureBox)ctrl).Tag) - 1] = 
                                    (data[Convert.ToInt32(((PictureBox)ctrl).Tag)] == 0) ? false : true;
                            }

                        }
                        else { }
                    }
                }

                for(int i=0;i<16;i++)
                {
                    if(ad_input_states_arr[i] != ad_input_states_arr_old[i])
                    {
                        ad_input_states_arr_old[i] = ad_input_states_arr[i];
                        WriteDataToFile(i, ad_input_states_arr[i]);
                        //break;
                    }
                }

            }));
        }

        private void ParseReadAnalogLogic(byte[] data)
        {
            this.Invoke(new EventHandler(delegate
            {
            foreach (Control ctrl in gbAnalogSensor.Controls)
            {
                if (data.Length == 3)
                {
                    ad_text.analog_text_arr[data[0] - 1].input_value = (float)(BitConverter.ToInt16(data, 1)) / 100.0f;
                    ad_text.analog_text_arr[data[0] - 1].convert_value = AdText.CalcAnyChannelAngConvValue(ad_text, data[0] - 1);
                    ad_text.analog_text_arr[data[0] - 1].dis_process_value = AdText.CalcAnyChannelAngDisRadio(ad_text, data[0] - 1);

                    if (ctrl is Label && ctrl.Tag != null && Convert.ToInt32(((Label)ctrl).Tag) < 20)
                    {
                        if (Convert.ToInt32(((Label)ctrl).Tag) == data[0])
                            // ((Label)ctrl).Text = (((data[2] << 8) | data[1]) / StaticDef.factorAnalogyAmplify).ToString("F3");
                            // ((Label)ctrl).Text = ((float)(BitConverter.ToInt16(data, 1)) / 100.0f).ToString("F2");
                            ((Label)ctrl).Text = $"{ad_text.analog_text_arr[data[0] - 1].convert_value}";

                    }
                    else if (ctrl is VerticalProgressBar.VerticalProgressBar)
                    {
                        ((VerticalProgressBar.VerticalProgressBar)ctrl).Value =
                            //(int)((float)(BitConverter.ToInt16(data, 1)) / 100.0f);
                            (int)ad_text.analog_text_arr[data[0] - 1].dis_process_value;
                    }
                }
                else if (data.Length == 33 && 0xff == data[0])
                {
                        for (int i = 0; i < 16; i++)
                        {
                            ad_text.analog_text_arr[i].input_value = (float) (BitConverter.ToInt16(data, Convert.ToInt32(i * 2 + 1))) / 100.0f  ;
                        }

                        AdText.CalcDisRadio(ad_text.analog_text_arr);

                        if (ctrl is Label && ctrl.Tag != null && Convert.ToInt32(((Label)ctrl).Tag) < 20)
                        {
                            //((Label)ctrl).Text = (((data[Convert.ToInt32(((Label)ctrl).Tag) * 2] << 8) | data[Convert.ToInt32(((Label)ctrl).Tag) * 2 - 1]) / StaticDef.factorAnalogyAmplify).ToString("F3");
                            ((Label)ctrl).Text =
                                    //((float)(BitConverter.ToInt16(data, Convert.ToInt32(((Label)ctrl).Tag) * 2 - 1)) / 100.0f).ToString("F2");
                                    $"{ad_text.analog_text_arr[Convert.ToInt32(((Label)ctrl).Tag) - 1].convert_value}";
                        }
                        else if (ctrl is VerticalProgressBar.VerticalProgressBar)
                        {
                            ((VerticalProgressBar.VerticalProgressBar)ctrl).Value =
                        //(int)((float)(BitConverter.ToInt16(data, Convert.ToInt32(((VerticalProgressBar.VerticalProgressBar)ctrl).Tag) * 2 - 1)) / 100.0f);
                            (int)ad_text.analog_text_arr[Convert.ToInt32(((VerticalProgressBar.VerticalProgressBar)ctrl).Tag) - 1].dis_process_value;
                        }

                    }
                    else { }
                    
                }

            }));
        }
        static bool bFlagAutoReportOnoff = false;
        private void ParseReadMainboardParamLogic(byte[] data)
        {
            this.Invoke(new EventHandler(delegate
            { 
                bFlagAutoReportOnoff = (data[12] == 0) ? false : true;
                if (bFlagAutoReportOnoff)
                {
                    btnAutoReport.BackColor = Color.Green;
                    btnAutoReport.Text = "AutoReport OFF";
                }
                else
                {
                    btnAutoReport.BackColor = DefaultBackColor;
                    btnAutoReport.Text = "AutoReport ON";
                }
            }));
        }
        private void ParseOnoffAutoReportLogic()
        {
            this.Invoke(new EventHandler(delegate
            {
                if (bFlagAutoReportOnoff) {
                    btnAutoReport.BackColor = Color.Green;
                    btnAutoReport.Text = "AutoReport OFF";
                }
                else {
                    btnAutoReport.BackColor = DefaultBackColor;
                    btnAutoReport.Text = "AutoReport ON";
                }
            }));
        }

        private void ParseReadTempLogic(byte[] data)
        {
            this.Invoke(new EventHandler(delegate
            {
                foreach (Control ctrl in gbTempSensor.Controls)
                {
                    if (data.Length == 3)
                    {
                        ad_text.temp_text_arr[data[0] - 1].input_value = (float)(BitConverter.ToInt16(data, 1)) / 100.0f;
                        ad_text.temp_text_arr[data[0] - 1].convert_value = AdText.CalcAnyChannelTempConvValue(ad_text, data[0] - 1);
                        ad_text.temp_text_arr[data[0] - 1].dis_process_value = AdText.CalcAnyChannelTempDisRadio(ad_text, data[0] - 1);

                        if (ctrl is Label && ctrl.Tag != null && Convert.ToInt32(((Label)ctrl).Tag) < 20)
                        {
                            if (Convert.ToInt32(((Label)ctrl).Tag) == data[0])
                            {
                                // ((Label)ctrl).Text = (((data[2] << 8) | data[1]) / 100.0f).ToString("F2");
                                ((Label)ctrl).Text =
                                          //((float)(BitConverter.ToInt16(data, 1)) / 100.0f).ToString("F2");
                                          $"{ad_text.temp_text_arr[data[0] - 1].convert_value}";
                                if(chkCF.Checked)
                                {
                                    float tmp = (float)(ad_text.temp_text_arr[data[0] - 1].convert_value * 1.8 + 32.0f);
                                    //if (tmp < 32) tmp = 32;
                                    ((Label)ctrl).Text = $"{tmp:F2}";
                                }
                            }
                            
                        }
                        else if (ctrl is VerticalProgressBar.VerticalProgressBar)
                        {
                            //int temp_dis = (int)((float)(BitConverter.ToInt16(data, 1)) / 100.0f);
                            //if (temp_dis < 0) temp_dis = -temp_dis;
                            
                            ((VerticalProgressBar.VerticalProgressBar)ctrl).Value =
                            //temp_dis;
                            (int)ad_text.temp_text_arr[data[0] - 1].dis_process_value;
                        }
                    }
                    else if (data.Length == 11 && 0xff == data[0])
                    {
                        for (int i = 0; i < 5; i++)
                        {
                            ad_text.temp_text_arr[i].input_value = (float)(BitConverter.ToInt16(data, Convert.ToInt32(i * 2 + 1))) / 100.0f;
                        }
                        AdText.CalcDisRadio(ad_text.temp_text_arr);

                        if (ctrl is Label && ctrl.Tag != null && Convert.ToInt32(((Label)ctrl).Tag) < 20)
                        {
                            // ((Label)ctrl).Text = (((data[Convert.ToInt32(((Label)ctrl).Tag) * 2] << 8) | data[Convert.ToInt32(((Label)ctrl).Tag) * 2 - 1]) / 100.0f).ToString("F2");
                            ((Label)ctrl).Text =
                                //((float)(BitConverter.ToInt16(data, Convert.ToInt32(((Label)ctrl).Tag) * 2 - 1)) /100.0f).ToString("F2");
                                $"{ad_text.temp_text_arr[Convert.ToInt32(((Label)ctrl).Tag) - 1].convert_value}";
                            if (chkCF.Checked)
                            {
                                float tmp = (float)(ad_text.temp_text_arr[Convert.ToInt32(((Label)ctrl).Tag) - 1].convert_value * 1.8 + 32.0f);
                                //if (tmp < 32) tmp = 32;
                                ((Label)ctrl).Text = $"{tmp:F2}";
                            } 

                        }
                        else if (ctrl is VerticalProgressBar.VerticalProgressBar)
                        {
                            //int temp_dis = (int)((float)(BitConverter.ToInt16(data, Convert.ToInt32(((VerticalProgressBar.VerticalProgressBar)ctrl).Tag) * 2 - 1)) / 100.0f);
                            //if (temp_dis < 0) temp_dis = -temp_dis;
                            ((VerticalProgressBar.VerticalProgressBar)ctrl).Value =
                            //temp_dis;
                            (int)ad_text.temp_text_arr[Convert.ToInt32(((VerticalProgressBar.VerticalProgressBar)ctrl).Tag) - 1].dis_process_value;
                        }

                    }
                    else { }
                }

            }));
        }

        #endregion

        private void btnConnect_Click(object sender, EventArgs e)
        {
            ConnectServer();
        }

        public void RcvConnectCmd()
        {
            ConnectServer();
        }

        public void RcvCloseCmd(ItemProp item)
        {
            
            //GC.Collect();

            if (item.itemIP != client_ip && item.itemTag != client_tag) return;
            if (isConnectStatus) btnConnect_Click(null, null);
        }
        public delegate void ConnectStatusHandlerDelegate(ItemProp itemStatusChange);
        public event ConnectStatusHandlerDelegate StatusChangeEvent;
        private void ItemStatusChange(ItemProp itemStatusChange)
        {
            if (StatusChangeEvent != null)
                StatusChangeEvent(itemStatusChange);
        }

        public delegate void RemovemeHandlerDelegate(string connection);
        public event RemovemeHandlerDelegate RemovemeEvent; 
        private void Removeme(string connectionIP)
        {
            if (RemovemeEvent != null)
                RemovemeEvent(connectionIP);
        }

        private void btnRemove_Click(object sender, EventArgs e)
        {
            if(isConnectStatus)
            {
                MessageBox.Show("Please close socket connection at first!");
                //btnConnect_Click(null, null);
                return;
            }
            if(MessageBox.Show("Would you really want to remove the board?","Remove board info:",MessageBoxButtons.YesNo,
                MessageBoxIcon.Question) == DialogResult.Yes)
            {
                Removeme($"{client_ip}:{client_port}");
            }
        }

        private void chkAutoReport_CheckedChanged(object sender, EventArgs e)
        {
            
        }

        private void btnAutoReport_Click(object sender, EventArgs e)
        {
            if (!isConnectStatus) return;
            Send(PacketType.AutoReportOnoffCmd,
                new byte[1] { bFlagAutoReportOnoff ? (byte)0 : (byte)1 }, client_tag);
        }

        private void chkTmr_CheckedChanged(object sender, EventArgs e)
        {  
            client_tmr.Enabled = chkTmr.Checked & isConnectStatus;
        }

        private void chkCF_CheckedChanged(object sender, EventArgs e)
        {
            string iniFile = $"{Application.StartupPath}\\Settings\\{client_ip}.ini";
            if(chkCF.Checked)
            {
                IniHelper.INIWriteValue(iniFile,"TemperatureProp","DisplayUnit", "F");
            }
            else
            {
                IniHelper.INIWriteValue(iniFile, "TemperatureProp", "DisplayUnit", "C");
            }
        }

        private void btnChange_Click(object sender, EventArgs e)
        {
            if (isConnectStatus) return;
            string ini_file = $"{Application.StartupPath}\\Settings\\{client_ip}.ini";
            WinExec(@"C:\WINDOWS\system32\notepad.exe " + $"{ini_file}", 5);
        }
    }
}
